module mooreb(x, r, c, z);
	input x, r, c;
	output z;
	reg z;
	reg [2:0] nxt, present;
	parameter aa = 0, bb = 1, cc = 2, dd = 3, ee = 4, ff = 5;
	
	always @ (present or x) 
	begin
		z = 0;
	
		case(present)
			aa:
				if(x == 0) nxt = bb;
				else nxt = aa;
				
			bb:
				if(x == 0) nxt = bb;
				else nxt = cc;
				
			cc:
				if(x == 0) nxt = dd;
				else nxt = aa;
				
			dd:
				if(x == 0) nxt = bb;
				else nxt = ee;
				
			ee:
				if(x == 0) nxt = dd;
				else nxt = ff;
				
			ff:
				if(x == 0) nxt = bb;
				else nxt = aa;
			
			default:
				nxt = aa;
		endcase
		
		if (present == ff) z = 1;
	end
	
	always @ (posedge c or negedge r) 
	begin
		if(r == 0) present = aa;
		else present = nxt;
	end
endmodule